#include <p32xxxx.h>
.set noreorder
.set noat
  
__InitDone = 0
__OsStarted = 1 
__StatisticsOn = 2
__Filler3 = 3
__SwitchNotification = 4
__TimeSharing = 5
__Filler6 = 6
__InScheduler = 7

__at = 52
__v0 = 56
__v1 = 60
__a0 = 64
__a1 = 68
__a2 = 72
__a3 = 76
__t0 = 80
__t1 = 84
__t2 = 88
__t3 = 92
__t4 = 96
__t5 = 100
__t6 = 104
__t7 = 108
__t8 = 112
__t9 = 116
__s0 = 120
__s1 = 124
__s2 = 128
__s3 = 132
__s4 = 136
__s5 = 140
__s6 = 144
__s7 = 148
__s8 = 152
__ra = 156
__HI = 160
__LO = 164
__SP = 168
__SR = 172
__EPC =176
__StatCount = 180

__STAT = 1
__NOTIF = 1



    .global qqqGetMem_Last
 .ent qqqGetMem_Last
qqqGetMem_Last:
	la		$v0,_stack	
    jr		$ra
	nop
 .end qqqGetMem_Last

    .global qqqGetMem_HeapSize
    .set noreorder
 .ent qqqGetMem_HeapSize
qqqGetMem_HeapSize:
	la		$v0,_min_heap_size	
    jr		$ra
	nop
 .end qqqGetMem_HeapSize

    .global qqqGetMem_Heap
    .set noreorder
 .ent qqqGetMem_Heap
qqqGetMem_Heap:
	la		$v0,_heap	
    jr		$ra
	nop
 .end qqqGetMem_Heap

    .global qqqStart1
 .ent qqqStart1
qqqStart1:
	lw		$t0, %gp_rel(qvRdyList)($gp)
	sw		$t0, %gp_rel(qvCurTcb)($gp)
	lw		$at, __at($t0)
	lw		$v0, __v0($t0)
	lw		$v1, __v1($t0)
	lw		$a0, __a0($t0)
	lw		$a1, __a1($t0)
	lw		$a2, __a2($t0)
	lw		$a3, __a3($t0)
	lw		$t2, __t2($t0)
	lw		$t3, __t3($t0)
	lw		$t4, __t4($t0)
	lw		$t5, __t5($t0)
	lw		$t6, __t6($t0)
	lw		$t7, __t7($t0)
	lw		$t8, __t8($t0)
	lw		$t9, __t9($t0)
	lw		$s0, __s0($t0)
	lw		$s1, __s1($t0)
	lw		$s2, __s2($t0)
	lw		$s3, __s3($t0)
	lw		$s4, __s4($t0)
	lw		$s5, __s5($t0)
	lw		$s6, __s6($t0)
	lw		$s7, __s7($t0)
	lw		$s8, __s8($t0)
	lw		$ra, __ra($t0)
	lw		$sp, __SP($t0)
	lw		$t1, __t1($t0)
    jr		$ra
	lw		$t0, __t0($t0)
 .end qqqStart1

	.ent qqqSwitchThread
	.global qqqSwitchThreadFromWait
qqqSwitchThreadFromWait:
1:	ll		$t0, %gp_rel(qvInCritical)($gp)			/* Lower InCritical (part 1 of EXIT_CRITICAL) */
	addiu	$t0, $t0, -1
	sc		$t0, %gp_rel(qvInCritical)($gp)
	beq		$t0, $zero, 1b
	lw		$t0, %gp_rel(qvInCritical)($gp)			/* Delay slot OK Are we still in a critical section */
	beq		$t0, $zero, 2f							/* Continue if we are out of a critical section */ 
	nop	
	b		999f
	nop	
	
	
    .global qqqSwitchThread
qqqSwitchThread:
/* From here:
		$t7 = qvCurTcb
		$t6 = qvKernel 
*/
1:	ll		$t0, %gp_rel(qvInCritical)($gp)			/* Lower InCritical (part 1 of EXIT_CRITICAL) */
	addiu	$t0, $t0, -1
	sc		$t0, %gp_rel(qvInCritical)($gp)
	beq		$t0, $zero, 1b
	lw		$t0, %gp_rel(qvInCritical)($gp)			/* Delay slot OK Are we still in a critical section */
	bne		$t0, $zero, 999f						/* Return if still in critical section */ 
#
 	lb		$t6, %gp_rel(qvKernel)($gp)				/* Delay slot OK */
	andi	$t0, $t6, (1<<__InScheduler)			/* InScheduler? */
	bne		$t0, $zero, 999f						/* Yes do and exit */
	nop

2:

#	di
#	ehb
#	mfc0	$t0, $12
#	ori		$t0, $t0, 0x400
#	mtc0	$t0, $12
#	ei
#	nop
	
#	lw		$t0, %gp_rel(qvSpawn)($gp)				/* Delay slot ok */
#	beq		$t0, $zero, 5f
#	lw		$t7, %gp_rel(qvCurTcb)($gp)				/* Always needed */
	
	addiu	$t1, $zero, 0x2							/* Set the qKernel interrupt */
	la		$t0, IFS0SET
	sw		$t1, 0($t0)
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	
	jr		$ra
	nop
	
5:	

.if __STAT==1
	andi	$t0, $t6, (1<<__StatisticsOn)			/* StatisticsOn */
	beq		$t0, $zero, 10f
	mfc0	$t0, $9									/* Copy counter from co-proc0 --LOAD_DELAY-- */
	lw		$t1, __StatCount($t7)					/* Save counters in TCB */
	addu	$t1, $t0, $t1
	sw		$t1, __StatCount($t7)					/* Save counters in TCB */
.endif
		
/* Save what we have to save. This qqqReschedule always comes from a thread */
10:	sw		$s0, __s0($t7)	
	sw		$s1, __s1($t7)	
	sw		$s2, __s2($t7)	
	sw		$s3, __s3($t7)	
	sw		$s4, __s4($t7)	
	sw		$s5, __s5($t7)	
	sw		$s6, __s6($t7)	
	sw		$s7, __s7($t7)	
	sw		$s8, __s8($t7)	
	sw		$ra, __ra($t7)
	sw		$ra, __EPC($t7)							/* Set also in EPC so an eret works always */
	sw		$sp, __SP($t7)	
	
/* NotifySwichOn */
.if (__NOTIF==1)
	andi	$t0, $t6, 1<<__SwitchNotification		/* SwitchNotification */
	beq		$t0, $zero, 20f							/* skip if NotifySwitch off */
	lw		$a1, %gp_rel(qvRdyList)($gp)
	addiu	$sp, $sp, -16
	jal		qNtfSwitch
	lw		$a0, %gp_rel(qvCurTcb)($gp)	
	addiu	$sp, $sp, +16
.endif

/* we lost all $t registers because of the posible notification call */ 
RestoreTcb:	
20:	lw		$t0, %gp_rel(qvRdyList)($gp)
	sw		$t0, %gp_rel(qvCurTcb)($gp)
	lw		$at, __at($t0)
	lw		$v0, __v0($t0)
	lw		$v1, __v1($t0)
	lw		$a0, __a0($t0)
	lw		$a1, __a1($t0)
	lw		$a2, __a2($t0)
	lw		$a3, __a3($t0)
	lw		$t2, __t2($t0)
	lw		$t3, __t3($t0)
	lw		$t4, __t4($t0)
	lw		$t5, __t5($t0)
	lw		$t6, __t6($t0)
	lw		$t7, __t7($t0)
	lw		$t8, __t8($t0)
	lw		$t9, __t9($t0)
	lw		$s0, __s0($t0)
	lw		$s1, __s1($t0)
	lw		$s2, __s2($t0)
	lw		$s3, __s3($t0)
	lw		$s4, __s4($t0)
	lw		$s5, __s5($t0)
	lw		$s6, __s6($t0)
	lw		$s7, __s7($t0)
	lw		$s8, __s8($t0)
	lw		$ra, __ra($t0)
	lw		$t1, __HI($t0)
	mthi	$t1
	lw		$t1, __LO($t0)
	mtlo	$t1
	lw		$sp, __SP($t0)
	lw		$t1, __t1($t0)
.if (__STAT==1)
	mtc0	$zero, $9								/* Clear the count for the new thread. */
.endif
	di
	ehb
	addu	$k1, $zero, $t0
	lw		$t0, __t0($k1)
	lw		$k0, __EPC($k1)
	mtc0	$k0, $14
	lw		$k0, __SR($k1)
	mtc0	$k0, $12
	eret


100:
	addiu	$t1, $zero, 0x2							/* Set the qKernel interrupt */
	la		$t0, IFS0SET
	sw		$t1, 0($t0)
999:
	jr		$ra
	nop
	
 .end qqqSwitchThread




    .global qqqFbrDequeue
    .set noreorder
.ent qqqFbrDequeue
qqqFbrDequeue:
	addiu	$sp, $sp, -4						/* stack space we use. 16byes we have we use in the leaf */
	sw		$ra, 16($sp)						/* 16 byes we have we use in the leaf */
	lw		$t0, %gp_rel(qvFbrMax)($gp)			/* Is the list empty. */
	lw		$t1, %gp_rel(qvFbrFree)($gp)		/* Max = Free */
	beq		$t0, $t1, 99f						/* Yes, we are done */
10:	lw		$t0, %gp_rel(qvFbrGet)($gp)			/* get pointer */
	addu	$t1, $t0, 12						/* next position = current + 12 */
	lw		$t2, %gp_rel(qvFbrEnd)($gp)			/* End of the list in t2 */
	lw		$t3, %gp_rel(qvFbrStart)($gp)		/* Begin of the list in t3 */
	sltu	$t4, $t1, $t2						/* $t4 = 1 if  $t1 < $t2 (Pos<End) */
	movz	$t1, $t3, $t4						/* $t1=$t3 (Begin) if $t4=0 */
	sw		$t1, %gp_rel(qvFbrGet)($gp)			/* write the new position back in get pointer */
#
20:	ll		$t1, %gp_rel(qvFbrFree)($gp)		/* Increment atomic FbrFree */
	addiu	$t1, $t1, 1
	sc		$t1,  %gp_rel(qvFbrFree)($gp)
	beq		$t1, $zero, 20b
#
	lw		$a1, 8($t0)							/* Get param 2 */
	lw		$a0, 4($t0)							/* delay slot Get Param 1 */
	lw		$t1, 0($t0)							/* get the address of the function to call */
	jal		$t1		
	sw		$zero, 0($t0)
/* After callling the fiber we are here */	
	lw		$t0, %gp_rel(qvFbrMax)($gp)			/* Is the list empty. */
	lw		$t1, %gp_rel(qvFbrFree)($gp)		/* Max = Free */
	bne		$t0, $t1, 10b						/* Yes, we are done */

99:	lw		$ra, 16($sp)
	jr		$ra
	addiu	$sp, $sp, 4
.end qqqFbrDequeue
	



/*********************************************************************
 * This is the actual interrupt handler that gets installed
 * in the interrupt vector table. It jumps to the core-timer
 * interrupt handler function.
 *
 * Note: The ".section .vector_1" is not allocatable. Hence to force
 * this section to be allocatable, use the "ax" directive.
 ********************************************************************/
.section .vector_1, "ax"
	j		qKernelIntHandler
	addu	$k1, $zero, $sp						/* Save SP in K1 in the delay slot */

/*********************************************************************
 * qKernelIntHandler()
 * Interrupt handler function for the qKernel interrupt. The function
 * calls qqScheduler.
 ********************************************************************/
____SP = 32
____EPC = 28
____SR = 24
____t1 = 20
____t0 = 16
.text
.ent qKernelIntHandler 
qKernelIntHandler:
	lw		$k0, %gp_rel(qvIntStack)($gp)		/* New stack Because we are in IntLevel 1 we can do this */
	addiu	$sp, $k0, -36						/* make room on the stack. SP is now the new stack */
	sw		$k1, ____SP($sp)					/* Save the old SP on the new stack */
	mfc0	$k1, $14							/* Copy EPC in k1 --LOAD_DELAY-- */
	lbu		$k0, %gp_rel(qvKernel)($gp)			/* The qKernel status */
	sw		$k1, ____EPC($sp)					/* Save EPC on the stack */
	andi	$k0, $k0, 1<<__StatisticsOn			/* StatisticsOn */
	beq		$k0, $zero, 2f						/* No skip statistics */
	nop
#	mfc0	$k1, $13							/* Copy Cause in k1 --LOAD_DELAY-- */
#	addiu	$k0, $zero, 1						/* Constant 1 in branch delay slot */ 
#	ins		$k1, $k0, 1, 27						/* Make the DC bit 1 (disable counting) */
#	mtc0	$k1, $13							/* Set Cause bit --LOAD_DELAY-- */

2:	mfc0	$k1, $12							/* Get the STATUS --LOAD_DELAY-- */
	addiu	$k0, $zero, 0b000001000000000		/* Interrupt level = 1 EXL=0 ERL=0 */
	sw		$k1, ____SR($sp)					/* Save STATUS on the stack */
	ins		$k1, $k0, 1, 15						/* Insert this in k1 and the status */
	mtc0	$k1, $12							/* Store in Status (IPL now RIPL) --LOAD_DELAY-- */
												/* From here we can get interrupted. Can't use K registers */
	sw		$t0, ____t0($sp)					/* Save t0 on the new stack */
	sw		$t1, ____t1($sp)					/* Save t1 on the new stack */
	
	la		$t0, IFS0CLR						/* clear the interrupt flag */
	addiu	$t1, $zero, 2
	sw		$t1, 0($t0)
	
	lw		$t0, %gp_rel(qvInCritical)($gp)		/* In critical section skip the scheduler */	
	bne		$t0, $zero, 199f
	
/* Save what we always have to save. */
	lw		$t0, %gp_rel(qvCurTcb)($gp)			/* in delay slot but thats ok */
	sw		$at, __at($t0)
	sw		$v0, __v0($t0)
	sw		$v1, __v1($t0)
	sw		$a0, __a0($t0)
	sw		$a1, __a1($t0)
	sw		$a2, __a2($t0)
	sw		$a3, __a3($t0)
	sw		$t2, __t2($t0)
	sw		$t3, __t3($t0)
	sw		$t4, __t4($t0)
	sw		$t5, __t5($t0)
	sw		$t6, __t6($t0)
	sw		$t7, __t7($t0)
	sw		$t8, __t8($t0)
	sw		$t9, __t9($t0)
	sw		$s8, __s8($t0)
	sw		$ra, __ra($t0)
	mfhi	$t1									/* HI register */
	sw		$t1, __HI($t0)						/* HI register */
	mflo	$t1									/* LO register */
	sw		$t1, __LO($t0)						/* LO register */

	lw		$t7, %gp_rel(qvCurTcb)($gp)				/* Always needed */
 	lb		$t6, %gp_rel(qvKernel)($gp)				/* This qvKernel is only used for non-changing things */

.if __STAT==1
	andi	$t0, $t6, (1<<__StatisticsOn)			/* StatisticsOn */
	beq		$t0, $zero, 4f
	mfc0	$t0, $9									/* Copy counter from co-proc0 --LOAD_DELAY-- */
	lw		$t1, __StatCount($t7)					/* Save counters in TCB */
	addu	$t1, $t0, $t1
	sw		$t1, __StatCount($t7)					/* Save counters in TCB */
.endif

/*	Now call the real scheduling job. There are 3 things to do.
	1 The Priority fibers (Bit 5->1) priority 4 to 1
	2 The queued fibers 
	3 The time related fibers						*/
4:	lb		$t0, %gp_rel(qvKernel)($gp)
	ori		$t0, 1<<__InScheduler					/* InScheduler is TRUE */
	sb		$t0, %gp_rel(qvKernel)($gp)
/* 	Small example for finding the highest prority 
	If priority 4 is set then ...0000.0010.0000 in qvSpawn */
	lw		$t5, %gp_rel(qvSpawn)($gp)				/*  */
5:	clz		$t1, $t5								/* leding zeros should be 26 in qvSpwan*/
	addiu	$t2, $zero, 32							/* 32 max */
	beq		$t1, $t2, 20f							/* Nothing to do so just jump over */
	subu	$t1, $t2, $t1							/* result now in t1 (example should be 6) */

10:	addiu	$t2, $zero, 1							/* constant 1 */
	subu	$t1, $t1, $t2							/* now it will be 5 (the 5th bit)*/
	sll		$t2, $t1								/* shift left example 1<<5 = 0010.0000  */
12:	ll		$t0, %gp_rel(qvSpawn)($gp)
	xor		$t0, $t2								/* clear the bit */
	sc		$t0, %gp_rel(qvSpawn)($gp)
	beq		$t0, $zero, 12b
	sll		$t1, 2									/* delay slot ok addressing is 32bit wide */
	la		$t4, qvSpawnFun
	addu	$t4, $t1, $t4							/* addres of qvSpawnFun at the correct index */
	lw		$t0, 0($t4)								/* We have the address */
	jal		$t0
	nop
	lw		$t5, %gp_rel(qvSpawn)($gp)				/* Branch delay slot OK. We always reread this */
	clz		$t1, $t5								/* leding zeros should be 27 in qvSpwan*/
	addiu	$t2, $zero, 32							/* 32 max */
	bne		$t1, $t2, 10b							/* Nothing to do so just jump over */	
	subu	$t1, $t2, $t1							/* result now in t1 (example should be 6) */

20:	lb		$t0, %gp_rel(qvKernel)($gp)
	andi	$t0, %LO(~(1<<__InScheduler))			/* InScheduler now false*/
	sb		$t0, %gp_rel(qvKernel)($gp)
	

/* NotifySwichOn */
.if (__NOTIF==1)
	andi	$t0, $t6, 1<<__SwitchNotification		/* SwitchNotification */
	beq		$t0, $zero, 20f							/* skip if NotifySwitch off */
	lw		$a1, %gp_rel(qvRdyList)($gp)
	addiu	$sp, $sp, -16
	jal		qNtfSwitch
	lw		$a0, %gp_rel(qvCurTcb)($gp)	
	addiu	$sp, $sp, +16
.endif


20:	lw		$v0, %gp_rel(qvRdyList)($gp)
	lw		$v1, %gp_rel(qvCurTcb)($gp)			/* Branch slot */
	beq		$v0, $v1, 100f						/* No Thread switch then jump to 100 */
/* Here if the scheduler wants us to switch the thread. Save all the stuff that we want to save
   on the TCB of the thread that is active */
	lw		$t0, %gp_rel(qvCurTcb)($gp)			/* qvCurTcb = qvRdyList (set t0 in delay slot) */
	lw		$v0, ____SP($sp)					/* Get SP from the new stack */
	sw		$v0, __SP($v1)						/* Store SP in the TCB */
	lw		$v0, ____EPC($sp)					/* EPC */
	sw		$v0, __EPC($v1)						/* EPC */
	lw		$v0, ____SR($sp)					/* SAVED Status */
	sw		$v0, __SR($v1)						/* Status */
	lw		$v0, ____t0($sp)					/* t0 */
	sw		$v0, __t0($v1)						/* t0 */
	lw		$v0, ____t1($sp)					/* t1 */
	sw		$v0, __t1($v1)						/* t1 */
	sw		$s0, __s0($t0)
	sw		$s1, __s1($t0)
	sw		$s2, __s2($t0)
	sw		$s3, __s3($t0)
	sw		$s4, __s4($t0)
	sw		$s5, __s5($t0)
	sw		$s6, __s6($t0)
	sw		$s7, __s7($t0)

	lw		$t0, %gp_rel(qvRdyList)($gp)
	sw		$t0, %gp_rel(qvCurTcb)($gp)			/* qvCurTcb = qvRdyList */

	lw		$at, __at($t0)
	lw		$v0, __v0($t0)
	lw		$v1, __v1($t0)
	lw		$a0, __a0($t0)
	lw		$a1, __a1($t0)
	lw		$a2, __a2($t0)
	lw		$a3, __a3($t0)
	lw		$t2, __t2($t0)
	lw		$t3, __t3($t0)
	lw		$t4, __t4($t0)
	lw		$t5, __t5($t0)
	lw		$t6, __t6($t0)
	lw		$t7, __t7($t0)
	lw		$t8, __t8($t0)
	lw		$t9, __t9($t0)
	lw		$s0, __s0($t0)
	lw		$s1, __s1($t0)
	lw		$s2, __s2($t0)
	lw		$s3, __s3($t0)
	lw		$s4, __s4($t0)
	lw		$s5, __s5($t0)
	lw		$s6, __s6($t0)
	lw		$s7, __s7($t0)
	lw		$s8, __s8($t0)
	lw		$ra, __ra($t0)
	lw		$t1, __HI($t0)
	mthi	$t1
	lw		$t1, __LO($t0)
	mtlo	$t1
	lw		$sp, __SP($t0)
	lw		$t1, __t1($t0)
	
	di
	ehb
	addu	$k1, $zero, $t0
	lw		$t0, __t0($k1)
	lw		$k0, __EPC($k1)
	mtc0	$k0, $14
	lw		$k0, __SR($k1)
	mtc0	$k0, $12
	eret

/* 	Here if we don't have to do tread switches so we just have to leave the interrupt 
	We still have to restore most of the registers because they were used by the interrupt */
100:	
	lw		$at, __at($t0)
	lw		$v0, __v0($t0)
	lw		$v1, __v1($t0)
	lw		$a0, __a0($t0)
	lw		$a1, __a1($t0)
	lw		$a2, __a2($t0)
	lw		$a3, __a3($t0)
	lw		$t2, __t2($t0)
	lw		$t3, __t3($t0)
	lw		$t4, __t4($t0)
	lw		$t5, __t5($t0)
	lw		$t6, __t6($t0)
	lw		$t7, __t7($t0)
	lw		$t8, __t8($t0)
	lw		$t9, __t9($t0)
	lw		$s8, __s8($t0)
	lw		$ra, __ra($t0)
	lw		$t1, __HI($t0)						/* HI register */
	mthi	$t1									/* HI register */
	lw		$t1, __LO($t0)						/* HI register */
	mtlo	$t1									/* HI register */
/* Here if we only have to restore t1 and t0 and return from the interrupt */
199:
	lw		$t1, ____t1($sp)					/* Restore t1 from stack */
	lw		$t0, ____t0($sp)					/* Restore t0 from stack */
	di
	ehb
	lw		$k0, ____EPC($sp)					/* Get EPC from stack */
	mtc0	$k0, $14							/* Store in EPC */
	lw		$k0, ____SR($sp)					/* Load saved status in k0 */
	lw		$sp, ____SP($sp)					/* Original SP */
	mtc0 	$k0, $12							/* load the status in CP0 */
	eret										/* done */

.end qKernelIntHandler



/*	qENTER_CRITICAL();
	do {
		qSupAtomicOR(qvUSec->IFSBits,qvUSec->IEC);		// Enable interrupts
		asm volatile ("nop");
		qSupAtomicAND(~(qvUSec->IFSBits),qvUSec->IEC);	// Disable interrupts
	
		uSec = qvUSec->Counter;
		tmp = (INT16U)*qvUSec->TMR;						// read the timer Only the first 16 bits
		if (mips>64) 
			tmp = tmp<<1;								// Count is 2 uSec 
		tmp = tmp / qvUSec->Mips;						// now # micro seconds to add
		uSec += tmp;									// Add it to the result
	} while (*qvUSec->IFS & qvUSec->IFSBits);
	qEXIT_CRITICAL();
	qSupAtomicOR(qvUSec->IFSBits,qvUSec->IEC);			// Enable interrupts
	return uSec;

*/

.section .text
.weak qqqGetUSec
.ent qqqGetUSec
qqqGetUSec:
	la		$t7, IFS0							/* IFS0 address save in t7 */
	lw		$t6, %gp_rel(qvTmrMsk)($gp)			/* The mask to set or clear bits */
	lw		$t5, %gp_rel(qvTmrTMR)($gp)			/* Adress of the timer */	
	
20:	sw		$t6, 0x38($t7)						/* Enable timer interrupt.  0x38 IEC0 +8 SET*/
	nop
	sw		$t6, 0x34($t7)						/* Disable timer interrupt. 0x30 IEC0 +4 CLR */
	lw		$t0, 0($t5)							/* Get the timer value */
	lb		$t1, %gp_rel(qvUSecDivider)($gp)	/* qvMIPS contains the number of mips 1->999 */
	divu	$zero, $t0, $t1
	mflo	$t3									/* t3 = TMR/Mips */
	lw		$v0, %gp_rel(qvUSec+0)($gp)
	lw		$v1, %gp_rel(qvUSec+4)($gp)
	addu	$v0, $v0, $t3
	sltu	$t2, $v0, $t3						/* see if any carry ???*/
	addu	$v1, $v1, $t2						/* result in v0-v1 */
	
	lw		$t0, 0($t7)							/* Get IFS0 */
	and		$t0, $t0, $t6						/* Timer interrupt ON */
	bne		$t0, $zero, 20b						/* If Yes redo the whole process */
	
	jr		$ra
	sw		$t6, 0x38($t7)						/* Enable timer interrupt. 0x30 IEC0 +8 SET */
	
.end qqqGetUSec
.section .text
.weak qqqGetUSecPart
.ent qqqGetUSecPart
qqqGetUSecPart:
	la		$t7, IFS0							/* IFS0 address save in t7 */
	lw		$t6, %gp_rel(qvTmrMsk)($gp)			/* The mask to set or clear bits */
	lw		$t5, %gp_rel(qvTmrTMR)($gp)			/* Adress of the timer */	
	
20:	sw		$t6, 0x38($t7)						/* Enable timer interrupt.  0x38 IEC0 +8 SET*/
	nop
	sw		$t6, 0x34($t7)						/* Disable timer interrupt. 0x30 IEC0 +4 CLR */
	lw		$t0, 0($t5)							/* Get the timer value */
	lb		$t1, %gp_rel(qvUSecDivider)($gp)	/* qvMIPS contains the number of mips 1->999 */
	divu	$zero, $t0, $t1
	mflo	$v0									/* v0 = TMR/Mips */
	
	lw		$t0, 0($t7)							/* Get IFS0 */
	and		$t0, $t0, $t6						/* Timer interrupt ON */
	bne		$t0, $zero, 20b						/* If Yes redo the whole process */
	
	jr		$ra
	sw		$t6, 0x38($t7)						/* Enable timer interrupt. 0x30 IEC0 +8 SET */
	
.end qqqGetUSecPart

.set reorder
.set at

